Package ej.mwt.style.background

## Class RoundedBackground

- java.lang.Object
- - ej.mwt.style.background.RoundedBackground

- All Implemented Interfaces:
    `Background`

      public class RoundedBackground
      extends Object
      implements Background

  Draws a plain color on the background with a round corner.

  Should be used in association with a `RoundedBorder` (using same color, corner radius and border thickness) to:

  - draw the border,
  - anti-alias the corner edges (blending color with background).

  The corner radius and border thickness are stored as a `char` for heap optimization and therefore cannot exceed `65535`.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `RoundedBackground​(int color, int cornerRadius)` | Deprecated. use `RoundedBackground(int, int, int)`
    `RoundedBackground​(int color, int cornerRadius, int borderThickness)` | Creates a rounded background.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `apply​(GraphicsContext g, int width, int height)` | Applies the background on a graphics context.
    `boolean` | `equals​(Object obj)` | Indicates whether some other object is "equal to" this one.
    `int` | `getBorderThickness()` | Gets the border thickness.
    `int` | `getColor()` | Gets the color.
    `int` | `getCornerRadius()` | Gets the corner radius.
    `int` | `hashCode()` | Returns a hash code value for the object.
    `boolean` | `isTransparent​(int width, int height)` | Tells whether or not this background is transparent.

    - ### Methods inherited from class java.lang.Object

      `clone, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### RoundedBackground

          @Deprecated
          public RoundedBackground​(int color,
                                   int cornerRadius)

      Deprecated.
      use `RoundedBackground(int, int, int)`
      Creates a rounded background.

      The given corner radius is clamped between `0` and `Character.MAX_VALUE`.

      Parameters:
        `color` - the color.
        `cornerRadius` - the corner radius.

    - #### RoundedBackground

          public RoundedBackground​(int color,
                                   int cornerRadius,
                                   int borderThickness)

      Creates a rounded background.

      The given corner radius and border thickness are clamped between `0` and `Character.MAX_VALUE`.

      Parameters:
        `color` - the color.
        `cornerRadius` - the corner radius.
        `borderThickness` - the border thickness.

  - ### Method Detail

    - #### getColor

          public int getColor()

      Gets the color.
      Returns:
        the color.

    - #### getCornerRadius

          public int getCornerRadius()

      Gets the corner radius.
      Returns:
        the corner radius.

    - #### getBorderThickness

          public int getBorderThickness()

      Gets the border thickness.
      Returns:
        the border thickness.

    - #### isTransparent

          public boolean isTransparent​(int width,
                                       int height)

      Description copied from interface: `Background`
      Tells whether or not this background is transparent.

      A background is considered as transparent if it does not draw every pixel with maximal opacity when it is applied. If a widget has a transparent background, its parent has to be rendered before the widget.

      Specified by:
        `isTransparent` in interface `Background`
      Parameters:
        `width` - the width of the background.
        `height` - the height of the background.
      Returns:
        `true` if the background is transparent, `false` otherwise.

    - #### apply

          public void apply​(GraphicsContext g,
                            int width,
                            int height)

      Description copied from interface: `Background`
      Applies the background on a graphics context.
      Specified by:
        `apply` in interface `Background`
      Parameters:
        `g` - the graphics context.
        `width` - the width of the background.
        `height` - the height of the background.

    - #### equals

          public boolean equals​(@Nullable
                                Object obj)

      Description copied from class: `Object`
      Indicates whether some other object is "equal to" this one.

      The `equals` method implements an equivalence relation on non-null object references:

      - It is reflexive: for any non-null reference value `x`, `x.equals(x)` should return `true`.
      - It is symmetric: for any non-null reference values `x` and `y`, `x.equals(y)` should return `true` if and only if `y.equals(x)` returns `true`.
      - It is transitive: for any non-null reference values `x`, `y`, and `z`, if `x.equals(y)` returns `true` and `y.equals(z)` returns `true`, then `x.equals(z)` should return `true`.
      - It is consistent: for any non-null reference values `x` and `y`, multiple invocations of `x.equals(y)` consistently return `true` or consistently return `false`, provided no information used in `equals` comparisons on the objects is modified.
      - For any non-null reference value `x`, `x.equals(null)` should return `false`.

      The `equals` method for class `Object` implements the most discriminating possible equivalence relation on objects; that is, for any non-null reference values `x` and `y`, this method returns `true` if and only if `x` and `y` refer to the same object (`x == y` has the value `true`).

      Note that it is generally necessary to override the `hashCode` method whenever this method is overridden, so as to maintain the general contract for the `hashCode` method, which states that equal objects must have equal hash codes.

      Specified by:
        `equals` in interface `Background`
      Overrides:
        `equals` in class `Object`
      Parameters:
        `obj` - the reference object with which to compare.
      Returns:
        `true` if this object is the same as the obj argument; `false` otherwise.
      See Also:
        `Object.hashCode()`, `HashMap`

    - #### hashCode

          public int hashCode()

      Description copied from class: `Object`
      Returns a hash code value for the object. This method is supported for the benefit of hash tables such as those provided by `HashMap`.

      The general contract of `hashCode` is:

      - Whenever it is invoked on the same object more than once during an execution of a Java application, the `hashCode` method must consistently return the same integer, provided no information used in `equals` comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application.
      - If two objects are equal according to the `equals(Object)` method, then calling the `hashCode` method on each of the two objects must produce the same integer result.
      - It is not required that if two objects are unequal according to the `Object.equals(java.lang.Object)` method, then calling the `hashCode` method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hash tables.

      As much as is reasonably practical, the hashCode method defined by class `Object` does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)

      Specified by:
        `hashCode` in interface `Background`
      Overrides:
        `hashCode` in class `Object`
      Returns:
        a hash code value for this object.
      See Also:
        `Object.equals(java.lang.Object)`, `System.identityHashCode(java.lang.Object)`